"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseStatusRouter = void 0;
const express_1 = __importDefault(require("express"));
class BaseStatusRouter {
    constructor(params) {
        var _a, _b;
        this.logger = (_a = params.logger) !== null && _a !== void 0 ? _a : console;
        this.path = (_b = params.path) !== null && _b !== void 0 ? _b : '';
        this.router = express_1.default.Router();
        this.router.get(this.path, this.get.bind(this));
    }
    get(_request, _response) {
        return __awaiter(this, void 0, void 0, function* () {
            const errorMsg = 'Method not implemented.';
            this.logger.log(errorMsg);
            throw new Error(errorMsg);
        });
    }
    status(_params) {
        return __awaiter(this, void 0, void 0, function* () {
            const errorMsg = 'Method not implemented.';
            this.logger.log(errorMsg);
            throw new Error(errorMsg);
        });
    }
}
exports.BaseStatusRouter = BaseStatusRouter;
//# sourceMappingURL=BaseStatusRouter.js.map