"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseTransactionRouter = void 0;
const express_1 = __importDefault(require("express"));
const JSURL = __importStar(require("@bedrock-foundation/jsurl"));
const shared_1 = require("./shared");
class BaseTransactionRouter {
    constructor(params) {
        var _a, _b, _c, _d;
        this.logger = (_a = params.logger) !== null && _a !== void 0 ? _a : console;
        this.label = (_b = params.label) !== null && _b !== void 0 ? _b : BaseTransactionRouter.label;
        this.icon = (_c = params.icon) !== null && _c !== void 0 ? _c : BaseTransactionRouter.icon;
        this.path = (_d = params.path) !== null && _d !== void 0 ? _d : '';
        this.router = express_1.default.Router();
        this.router.get(this.path, this.get.bind(this));
        this.router.post(this.path, this.post.bind(this));
    }
    get(request, response) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const { label, icon } = JSURL.parse(request.query.params);
            try {
                response.status(shared_1.StatusCodes.OK).json({
                    label: (_a = label !== null && label !== void 0 ? label : this.label) !== null && _a !== void 0 ? _a : BaseTransactionRouter.label,
                    icon: (_b = icon !== null && icon !== void 0 ? icon : this.icon) !== null && _b !== void 0 ? _b : BaseTransactionRouter.icon,
                });
            }
            catch (e) {
                this.logger.error(e);
                response.status(shared_1.StatusCodes.BAD_REQUEST).send();
            }
        });
    }
    post(_request, _response) {
        return __awaiter(this, void 0, void 0, function* () {
            const errorMsg = 'Method not implemented.';
            this.logger.log(errorMsg);
            throw new Error(errorMsg);
        });
    }
    validateTransactionRequest(_request) {
        const errorMsg = 'Method not implemented.';
        this.logger.log(errorMsg);
        throw new Error(errorMsg);
    }
    createTransaction(_params) {
        return __awaiter(this, void 0, void 0, function* () {
            const errorMsg = 'Method not implemented.';
            this.logger.log(errorMsg);
            throw new Error(errorMsg);
        });
    }
}
exports.BaseTransactionRouter = BaseTransactionRouter;
BaseTransactionRouter.label = 'Bedrock Foundation';
BaseTransactionRouter.icon = 'https://storage.googleapis.com/bedrock-platform-assets-production-mainnet/brand/bedrock-logo.png';
//# sourceMappingURL=BaseTransactionRouter.js.map