"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorsToMessage = exports.validate = exports.hasErrors = exports.encodeError = void 0;
const encodeError = (message, error) => {
    error.message = message;
    return error;
};
exports.encodeError = encodeError;
const hasErrors = (errors) => errors.length > 0;
exports.hasErrors = hasErrors;
const validate = (schema, params) => {
    var _a;
    const validator = schema.validate(params);
    const { value, error } = validator;
    return {
        value,
        errors: (_a = error === null || error === void 0 ? void 0 : error.details) !== null && _a !== void 0 ? _a : [],
    };
};
exports.validate = validate;
const errorsToMessage = (errors) => errors.map((error) => error.message).join('\n');
exports.errorsToMessage = errorsToMessage;
//# sourceMappingURL=JoiUtil.js.map