import express from 'express';
export class BaseStatusRouter {
    constructor(params) {
        var _a, _b;
        this.logger = (_a = params.logger) !== null && _a !== void 0 ? _a : console;
        this.path = (_b = params.path) !== null && _b !== void 0 ? _b : '';
        this.router = express.Router();
        this.router.get(this.path, this.get.bind(this));
    }
    async get(_request, _response) {
        const errorMsg = 'Method not implemented.';
        this.logger.log(errorMsg);
        throw new Error(errorMsg);
    }
    async status(_params) {
        const errorMsg = 'Method not implemented.';
        this.logger.log(errorMsg);
        throw new Error(errorMsg);
    }
}
//# sourceMappingURL=BaseStatusRouter.js.map