import express from 'express';
import * as JSURL from '@bedrock-foundation/jsurl';
import { StatusCodes, } from './shared.mjs';
export class BaseTransactionRouter {
    constructor(params) {
        var _a, _b, _c, _d;
        this.logger = (_a = params.logger) !== null && _a !== void 0 ? _a : console;
        this.label = (_b = params.label) !== null && _b !== void 0 ? _b : BaseTransactionRouter.label;
        this.icon = (_c = params.icon) !== null && _c !== void 0 ? _c : BaseTransactionRouter.icon;
        this.path = (_d = params.path) !== null && _d !== void 0 ? _d : '';
        this.router = express.Router();
        this.router.get(this.path, this.get.bind(this));
        this.router.post(this.path, this.post.bind(this));
    }
    async get(request, response) {
        var _a, _b;
        const { label, icon } = JSURL.parse(request.query.params);
        try {
            response.status(StatusCodes.OK).json({
                label: (_a = label !== null && label !== void 0 ? label : this.label) !== null && _a !== void 0 ? _a : BaseTransactionRouter.label,
                icon: (_b = icon !== null && icon !== void 0 ? icon : this.icon) !== null && _b !== void 0 ? _b : BaseTransactionRouter.icon,
            });
        }
        catch (e) {
            this.logger.error(e);
            response.status(StatusCodes.BAD_REQUEST).send();
        }
    }
    async post(_request, _response) {
        const errorMsg = 'Method not implemented.';
        this.logger.log(errorMsg);
        throw new Error(errorMsg);
    }
    validateTransactionRequest(_request) {
        const errorMsg = 'Method not implemented.';
        this.logger.log(errorMsg);
        throw new Error(errorMsg);
    }
    async createTransaction(_params) {
        const errorMsg = 'Method not implemented.';
        this.logger.log(errorMsg);
        throw new Error(errorMsg);
    }
}
BaseTransactionRouter.label = 'Bedrock Foundation';
BaseTransactionRouter.icon = 'https://storage.googleapis.com/bedrock-platform-assets-production-mainnet/brand/bedrock-logo.png';
//# sourceMappingURL=BaseTransactionRouter.js.map