import express, { Request, Response } from 'express';
import { CreateTransactionResponse, CreateTransactionRequest } from '@bedrock-foundation/sdk';
import { MetadataRequest, MetadataResponse, TransactionRequest, TransactionResponse } from './shared';
export interface ActionRouter<T extends CreateTransactionRequest<any>> {
    logger: typeof console;
    label: string;
    icon: string;
    path: string;
    router: any;
    get(request: MetadataRequest<T>, response: MetadataResponse): Promise<void>;
    post(request: TransactionRequest<T>, response: TransactionResponse): Promise<void>;
    createTransaction: (request: T) => Promise<CreateTransactionResponse>;
}
export interface ActionRouterParams {
    logger?: typeof console;
    label?: string;
    icon?: string;
    path?: string;
}
export declare class BaseActionRouter implements ActionRouter<any> {
    static readonly label: string;
    static readonly icon: string;
    logger: typeof console;
    label: string;
    icon: string;
    path: string;
    router: express.Router;
    constructor(params: ActionRouterParams);
    get(request: MetadataRequest<any>, response: MetadataResponse): Promise<void>;
    post(_request: Request<{}, {}, {}, {}>, _response: Response): Promise<void>;
    createTransaction(_params: any): Promise<CreateTransactionResponse>;
}
