import express from 'express';
import { StatusResult } from '@bedrock-foundation/sdk';
import { HTTPRequest, HTTPResponse } from './shared';
export interface StatusRouter<QueryStringParams, ResponseData> {
    logger: typeof console;
    path: string;
    router: any;
    get(request: HTTPRequest<never, QueryStringParams>, response: HTTPResponse<ResponseData>): Promise<void>;
    status(params: QueryStringParams): Promise<StatusResult<ResponseData>>;
}
export declare type StatusRouterParams = {
    logger?: typeof console;
    label?: string;
    icon?: string;
    path?: string;
};
export declare class BaseStatusRouter<QueryStringParams, ResponseData> implements StatusRouter<QueryStringParams, ResponseData> {
    logger: typeof console;
    path: string;
    router: express.Router;
    constructor(params: StatusRouterParams);
    get(_request: HTTPRequest<never, QueryStringParams>, _response: HTTPResponse<ResponseData>): Promise<void>;
    status(_params: QueryStringParams): Promise<StatusResult<ResponseData>>;
}
