import express, { Request, Response } from 'express';
import { CreateTransactionRequest, CreateTransactionResponse, MetadataRequest, MetadataResponse, TransactionRequest, TransactionResponse } from './shared';
import * as JoiUtil from '../utils/JoiUtil';
export interface TransactionRouter<T extends CreateTransactionRequest<any>> {
    logger: typeof console;
    label: string;
    icon: string;
    path: string;
    router: any;
    get(request: MetadataRequest<T>, response: MetadataResponse): Promise<void>;
    post(request: TransactionRequest<T>, response: TransactionResponse): Promise<void>;
    validateTransactionRequest(request: T): JoiUtil.JoiValidatorResponse<T>;
    createTransaction(request: T): Promise<CreateTransactionResponse>;
}
export interface TransactionRouterParams {
    logger?: typeof console;
    label?: string;
    icon?: string;
    path?: string;
}
export declare class BaseTransactionRouter implements TransactionRouter<any> {
    static readonly label: string;
    static readonly icon: string;
    logger: typeof console;
    label: string;
    icon: string;
    path: string;
    router: express.Router;
    constructor(params: TransactionRouterParams);
    get(request: MetadataRequest<any>, response: MetadataResponse): Promise<void>;
    post(_request: Request<{}, {}, {}, {}>, _response: Response): Promise<void>;
    validateTransactionRequest(_request: any): JoiUtil.JoiValidatorResponse<any>;
    createTransaction(_params: any): Promise<CreateTransactionResponse>;
}
