import { PublicKey } from '@solana/web3.js';
import { AuthorizationParams, CreateAuthorizationTransactionRequest, CreateAuthorizationTransactionResponse } from '@bedrock-foundation/sdk';
import { RedisClientType } from 'redis';
import { ActionRouter, BaseActionRouter, ActionRouterParams } from '../../models/BaseActionRouter';
import { NonceRequest, NonceResponse, TransactionRequest, TransactionResponse } from '../../models/shared';
declare type AuthorizationRouterParams = ActionRouterParams & {
    redis: RedisClientType;
    io: any;
};
export declare const MEMO_PROGRAM_ID: PublicKey;
export declare class AuthorizationRouter extends BaseActionRouter implements ActionRouter<CreateAuthorizationTransactionRequest> {
    private redis;
    private io;
    noncePath: string;
    constructor(params: AuthorizationRouterParams);
    post(req: TransactionRequest<AuthorizationParams>, res: TransactionResponse): Promise<void>;
    createNonce(req: NonceRequest<AuthorizationParams>, res: NonceResponse): Promise<void>;
    createTransaction(request: CreateAuthorizationTransactionRequest): Promise<CreateAuthorizationTransactionResponse>;
}
export {};
