import Joi from 'joi';
import { PublicKey } from '@solana/web3.js';
import { AuthorizationParams } from '@bedrock-foundation/sdk';
import { RedisClientType } from 'redis';
import { TransactionRouter, BaseTransactionRouter, TransactionRouterParams } from '../../../models/BaseTransactionRouter';
import { CreateTransactionRequest, CreateTransactionResponse, NonceRequest, NonceResponse, TransactionRequest, TransactionResponse } from '../../../models/shared';
import * as JoiUtil from '../../../utils/JoiUtil';
export declare const authorizationParmsSchema: Joi.ObjectSchema<any>;
export declare const authorizationSchema: Joi.ObjectSchema<any>;
export declare type CreateAuthorizationTransactionRequest = CreateTransactionRequest<AuthorizationParams>;
export declare type CreateAuthorizationTransactionResponse = CreateTransactionResponse;
export declare const MEMO_PROGRAM_ID: PublicKey;
export declare type AuthorizationRouterParams = TransactionRouterParams & {
    redis: RedisClientType;
    io: any;
};
export declare class AuthorizationRouter extends BaseTransactionRouter implements TransactionRouter<CreateAuthorizationTransactionRequest> {
    private redis;
    private io;
    noncePath: string;
    constructor(params: AuthorizationRouterParams);
    post(req: TransactionRequest<AuthorizationParams>, res: TransactionResponse): Promise<void>;
    createNonce(req: NonceRequest<AuthorizationParams>, res: NonceResponse): Promise<void>;
    validateTransactionRequest(request: CreateAuthorizationTransactionRequest): JoiUtil.JoiValidatorResponse<CreateAuthorizationTransactionRequest>;
    createTransaction(request: CreateAuthorizationTransactionRequest): Promise<CreateAuthorizationTransactionResponse>;
}
