import Joi from 'joi';
import { TransferParams } from '@bedrock-foundation/sdk';
import { TransactionRouter, BaseTransactionRouter, TransactionRouterParams } from '../../../models/BaseTransactionRouter';
import { TransactionRequest, TransactionResponse, CreateTransactionRequest, CreateTransactionResponse } from '../../../models/shared';
import * as JoiUtil from '../../../utils/JoiUtil';
export declare const transferParamsSchema: Joi.ObjectSchema<any>;
export declare const transferSchema: Joi.ObjectSchema<any>;
export declare type CreateTransferTransactionRequest = CreateTransactionRequest<TransferParams>;
export declare type CreateTransferTransactionResponse = CreateTransactionResponse;
export declare class TransferRouter extends BaseTransactionRouter implements TransactionRouter<CreateTransferTransactionRequest> {
    constructor(params?: TransactionRouterParams);
    post(req: TransactionRequest<TransferParams>, res: TransactionResponse): Promise<void>;
    validateTransactionRequest(request: CreateTransferTransactionRequest): JoiUtil.JoiValidatorResponse<CreateTransferTransactionRequest>;
    createTransaction(request: CreateTransferTransactionRequest): Promise<CreateTransferTransactionResponse>;
}
