import Joi from 'joi';
import { GetReferenceStatusParams, StatusData } from '@bedrock-foundation/sdk';
import express from 'express';
import { HTTPRequest, HTTPResponse, StatusCodes } from '../../models/shared';
import * as JoiUtil from '../../utils/JoiUtil';
export declare const getReferenceStatusParamsSchema: Joi.ObjectSchema<any>;
export interface GetReferenceStatusResult {
    data?: StatusData;
    error?: Error;
    status: StatusCodes;
}
export declare type GetReferenceStatusRequest = HTTPRequest<never, GetReferenceStatusParams>;
export declare type GetReferenceStatusResponse = HTTPResponse<StatusData>;
export declare type StatusRouterParams = {
    logger: typeof console;
};
export declare class GetReferenceStatusRouter {
    logger: typeof console;
    path: string;
    router: express.Router;
    constructor(params: StatusRouterParams);
    get(request: GetReferenceStatusRequest, response: GetReferenceStatusResponse): Promise<void>;
    validateGetReferenceStatusParams(params: GetReferenceStatusParams): JoiUtil.JoiValidatorResponse<GetReferenceStatusParams>;
    status(params: GetReferenceStatusParams): Promise<GetReferenceStatusResult>;
}
