import Joi from 'joi';
import { EmptyWalletParams } from '@bedrock-foundation/sdk';
import { TransactionRouter, BaseTransactionRouter, TransactionRouterParams } from '../../models/BaseTransactionRouter';
import { TransactionRequest, TransactionResponse, CreateTransactionRequest, CreateTransactionResponse } from '../../models/shared';
import * as JoiUtil from '../../utils/JoiUtil';
export declare const emptyWalletParmsSchema: Joi.ObjectSchema<any>;
export declare const emptyWalletSchema: Joi.ObjectSchema<any>;
export declare type CreateEmptyWalletTransactionRequest = CreateTransactionRequest<EmptyWalletParams>;
export declare type CreateEmptyWalletTransactionResponse = CreateTransactionResponse;
export declare class EmptyWalletRouter extends BaseTransactionRouter implements TransactionRouter<CreateEmptyWalletTransactionRequest> {
    constructor(params?: TransactionRouterParams);
    post(request: TransactionRequest<EmptyWalletParams>, response: TransactionResponse): Promise<void>;
    validateTransactionRequest(request: CreateEmptyWalletTransactionRequest): JoiUtil.JoiValidatorResponse<CreateEmptyWalletTransactionRequest>;
    createTransaction(request: CreateEmptyWalletTransactionRequest): Promise<CreateEmptyWalletTransactionResponse>;
}
