import { PublicKey, Keypair, Connection, TransactionInstruction } from '@solana/web3.js';
export interface TransferSplTokensParams {
    transfers: TransferSplTokenParams[];
    validateFunds?: boolean;
}
export interface TransferSplTokenParams {
    fromAccountPublicKey: PublicKey;
    toAccountPublicKey: PublicKey;
    splTokenPublicKey: PublicKey;
    amount: number;
    feePayerPublicKey: PublicKey;
    refs: PublicKey[];
}
declare const SolanaUtil: {
    keyPairFromFile: (filePath: string) => Promise<Keypair>;
    printTokenAccounts: (connection: Connection, publicKey: PublicKey, label: string) => Promise<void>;
    getRandomNFTMintFromAccount: (connection: Connection, account: PublicKey) => Promise<PublicKey>;
    calculatePlatformFee: (amountInSol: number) => number;
    calculateMerchantFee: (amountInSol: number) => number;
    getTokenAccountBalance: (connection: Connection, ataPublicKey: PublicKey) => Promise<BigInt>;
    transferTokens: (params: TransferSplTokensParams) => Promise<TransactionInstruction[]>;
    transferToken: (params: TransferSplTokenParams) => Promise<TransactionInstruction[]>;
};
export default SolanaUtil;
